package com.huigou.topsun.base.orgImport.domain;

import com.huigou.topsun.common.AbstractPortalOrg;
import lombok.Getter;
import lombok.Setter;

import javax.persistence.*;

/**
 * 组织人员导入
 */
@Table(name = "tmp_org_person_data")
@Entity
@Getter
@Setter
public class TmpOrgPersonData extends AbstractPortalOrg {
    /**
     * 名称
     */
    @Column(name = "name")
    private String name;

    /**
     * 编码
     */
    @Column(name = "code")
    private String code;

    /**
     * 上级完整路径
     */
    @Column(name = "parent_name")
    private String parentName;


    /**
     * 性别
     */
    @Column(name = "sex")
    private String sex;

    /**
     * 排序号
     */
    @Column(name = "SORT_ID")
    private Integer sortId;

    /**
     * 是否SAP员工
     */
    @Column(name = "IS_SAP_PERSON")
    private String isSapPerson;

    /**
     * 语言
     */
    @Column(name = "LANGU")
    private String langu;

    /**
     * 国家
     */
    @Column(name = "COUNTRY")
    private String country;

    /**
     * 地区
     */
    @Column(name = "area")
    private String area;

    /**
     * 银行所属国家
     */
    @Column(name = "BANK_COUNTRY")
    private String bankCountry;

    /**
     * 银行代码
     */
    @Column(name = "BANK_CODE")
    private String bankCode;

    /**
     * 银行账号
     */
    @Column(name = "BANK_ACCOUNT_NUMBER")
    private String bankAccountNumber;

    /**
     * 参考明细
     */
    @Column(name = "CONSULT_ITEM")
    private String consultItem;

    /**
     * 公司代码
     */
    @Column(name = "COMPANY_CODE")
    private String companyCode;

    /**
     * email
     */
    @Column(name = "email")
    private String email;

    /**
     * 证件号码
     */
    @Column(name = "certificate_no")
    private String certificateNo;

    /**
     * 婚姻状况
     */
    @Column(name = "marriage")
    private String marriage;

    /**
     * 出生日期
     */
    @Column(name = "birthday")
    private String birthday;

    /**
     * 参加工作日期
     */
    @Column(name = "join_date")
    private String joinDate;

    /**
     * 学历
     */
    @Column(name = "degree")
    private String degree;

    /**
     * 毕业院校
     */
    @Column(name = "graduate_school")
    private String graduateSchool;

    /**
     * 专业
     */
    @Column(name = "speciality")
    private String speciality;

    /**
     * 移动电话
     */
    @Column(name = "mobile_phone")
    private String mobilePhone;

    /**
     * 办公室电话
     */
    @Column(name = "office_phone")
    private String officePhone;

    /**
     * 邮编
     */
    @Column(name = "zip")
    private String zip;

    /**
     * 家庭住址
     */
    @Column(name = "family_address")
    private String familyAddress;
}
